package org.dromara.work.service;

import org.dromara.work.domain.bo.TpCategoryBo;
import org.dromara.work.domain.vo.TpCategoryVo;

import java.util.Collection;
import java.util.List;

/**
 * 作品类目Service接口
 *
 * @author Maosw
 * @date 2025-04-11
 */
public interface ITpCategoryService {

    /**
     * 查询作品类目
     *
     * @param id 主键
     * @return 作品类目
     */
    TpCategoryVo queryById(Long id);


    /**
     * 查询符合条件的作品类目列表
     *
     * @param bo 查询条件
     * @return 作品类目列表
     */
    List<TpCategoryVo> queryList(TpCategoryBo bo);

    /**
     * 新增作品类目
     *
     * @param bo 作品类目
     * @return 是否新增成功
     */
    Boolean insertByBo(TpCategoryBo bo);

    /**
     * 修改作品类目
     *
     * @param bo 作品类目
     * @return 是否修改成功
     */
    Boolean updateByBo(TpCategoryBo bo);

    /**
     * 校验并批量删除作品类目信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 根据id查询子id
     *
     * @return 作品类目列表
     */
    List<Long> selectListIds(Long categoryId);
}
